<?php
// Web server access log viewer utility
//   Rob Broekhuis, 2004
// Feel free to use and modify as you see fit.  Please let me know if you
// find any problems:  peppercat@rcn.com
// last modified: 17 Mar 2004
// documentation: www.robsplants.com/accesslog.php

//
// default values for configuration parameters (see logconfig.ini for comments)
//
   $logdir="%DOC_ROOT%/logs/";
   $logfilebase="access.log";
   $logtoday=".%W.%w";
   $logthisweek=".%W.%w.gz";
   $logprevious=".%W.gz";
   $ipcluster=4;     $myips=0;     
   $mydomain="(none)"; 
   $show200=false;   $showhttp=false;     
   $whois=false;     $host=false;
   $useragent_truncate=90; 
   $bufsize=100;     $timeout=30;
   $ips=array();     $who=array();        $excludes=array();

//
// Process logconfig.ini
//
   if ($h=fopen("logconfig.ini","r")) {
      $s=configline($h);
      do {
         while ($s && $s{0}!="[") {$s=configline($h);}
         if ($s=="[IPs]") {
            $s=configline($h);
            while ($s && $s{0}!="[") {
               $i=strpos($s," ");
               if ($i) {
                  $ips[]=substr($s,0,$i);
                  $who[]=trim(substr($s,$i+1));
               }
               $s=configline($h);
            }   
         } elseif ($s=="[Excludes]") {
            $s=configline($h);
            while ($s && $s{0}!="[") {$excludes[]=$s; $s=configline($h);}
         } elseif ($s=="[Settings]" || $s=="[LogLocation]") {
            $s=configline($h);
            while ($s && $s{0}!="[") {
               if ($i=strpos($s," ")) {
                  $setvar=substr($s,0,$i);
                  $setvalue=substr($s,$i+1);
                  if (strpos(" !ipcluster!myips!mydomain!show200!showhttp!timeout!bufsize!whois!host!useragent_truncate!logdir!logfilebase!logtoday!logthisweek!logprevious!","!$setvar!")) {
                     if ($setvalue=="off") {$setvalue=false;}
                     $$setvar=$setvalue;
                  } else {echo "Unrecognized parameter in logconfig.ini: $s<br>";}
               }
               $s=configline($h);   
            }
         } else {echo "Unrecognized section in logconfig.ini: $s<br>";}   
      } while (!feof($h));            
      fclose($h);
   } else {echo "Cannot find logconfig.ini.  Using preset defaults.<br>";}

//
// handle querystring parameters
//

   if (isset($_GET['me'])) {$myips=0;}
   if (isset($_GET['all'])) {$excludes=array();}
   $server=(isset($_GET['whoserver']))?"&server=".$_GET['whoserver']:"";
   if (isset($_GET['cluster'])) {$ipcluster=$_GET['cluster'];}
   if (isset($_GET['date'])) {
      $date=strtotime($_GET['date']);
      if ($date==-1) {
         echo "I don't understand date: {$_GET['date']}<br>
               Please correct and retry.";
         exit;
      }
   } else {$date=strtotime(date("m/d/Y",time()));}

//
// find and open file
//
   $logdir=str_replace("~",$_SERVER['DOCUMENT_ROOT'],$logdir);
   $fdate=date("d/M/Y",$date);
   $week=date("W",$date);
   $wday=date("w",$date); if ($wday==0) {$wday=7;}
   $d=date("d",$date);
   $m=date("m",$date);
   $y=date("y",$date);
   $Y=date("Y",$date);
   $oldweek=($week!=date("W",time()));
   if (strlen($week)==1) {$week="0".$week;}
   if ($oldweek) {$logext=$logprevious;} 
      elseif (date("Y m d")==date("Y m d",$date)) {$logext=$logtoday; $today=1;}
      else {$logext=$logthisweek; }         
   $logext=str_replace(array("%w","%W","%d","%m","%y","%Y"),array($wday,$week,$d,$m,$y,$Y),$logext);
   $file=$logdir.$logfilebase.$logext;
   $zipped=(substr($file,-3)==".gz");
   if (!$zipped) {$handle=fopen($file,"r");} 
            else {$handle=gzopen($file,"r");}
   if (!$handle) {
      echo "I can't find a log in the location specified:<br>
           $file<br>
           Perhaps your site was not accessed on the specified day.  Check if
           you set the correct location parameters in logconfig.ini";
      exit;
   }

// display header

   echo "<style> body {font-family:Arial}
                 h1 {font-size:22px}
                 h2 {font-size:18px; margin-bottom:0px}
         </style>
         <title>Access log</title>";
   echo "<h1>Access log for ".date("F d, Y",$date)."</h1>";
   echo "<a href=\"$PHP_SELF?date=".date("m/d",$date-24*3600)."\">previous</a>";
   if (!$today) 
      {echo "&nbsp;<a href=\"$PHP_SELF?date=".date("m/d",$date+24*3600)."\">next</a>";}
   echo "<br>";
   
   fillbuffer();
   $e=getentry("");
   while ($e) {
      if ($newheader) {
         $ip=$e["ip"];
         $ipcut=$e["ipcut"];
         if ($whois || $host) {
            $iplink="<a href=\"whois.php?who=$whois&host=$host&ip=$ip$server\" onClick=".
               "\"window.open(this.href,'whois','height=400 width=500 scrollbars'); ".
               "return false;\">$ip</a>";
         } else {$iplink=$ip;}
         $i=0; while (($i<count($ips)) && (!ipmatch($ips[$i],$ip))) {$i++;}
         $id=($i==count($ips))?$iplink:"{$who[$i]} ($iplink)";
         $useragent=$e['useragent'];
         if ($useragent_truncate) {
            $useragent=substr($useragent,0,$useragent_truncate);
         }
         echo "<h2>$id. $useragent</h2>";
         if (($e["refer"]!="-")&&(strpos(" ".$e["refer"],$mydomain)<1)) {
            echo "<b>Referred by <a href=\"{$e['refer']}\">{$e['refer']}</a></b><br>";
         }
      }
      $err=($e['mode']!=200)&&($e['mode']!=304);
      $mode=($e['mode']==200 && !$show200)?"":" [{$e["mode"]}],";
      if (!$showhttp) {
         $p=strpos($e['request'],"HTTP/1");
         if ($p) {$e['request']=substr($e['request'],0,$p-1);}
      }   
      if ($e['domain']!=$mydomain&&$e['domain']!="www.$mydomain")
         {$e['request']="[".$e['domain']."] ".$e['request'];}
      if ($err) {echo "<b><font color=red>";}
      echo "{$e["time"]}:{$e["request"]}$mode ({$e["size"]} bytes)<br>";
      if ($err) {echo "</b></font>";}
      $e=getentry($e);
   }
   if ($zipped) {gzclose($handle);} else {fclose($handle);}
         
   function ipcutoff($ip,$n) {     //returns the first $n segments of ip string
      $i=0;
      $p=0;
      $ip.=".";
      do {
         $p=strpos($ip,".",$p+1);
         $i++;
      } while ($i<$n);
      return substr($ip,0,$p-1);
   }
   function ipmatch($ippat,$ip) { //returns true if $ip matches the specified
                                  //pattern $ippat  
      if ($j=strpos($ippat,"-")) {
         $i=$j;
         while (($ippat{$i}!=".") && $i) {$i--;}
         if (substr($ip,0,$i)!=substr($ippat,0,$i)) {return false;}
         $end=substr($ip,$i+1);
         if ($k=strpos($end,".")) {$end=substr($end,0,$k);}
         $min=substr($ippat,$i+1,$j-$i-1);
         if ($end<$min) {return false;}
         $max=substr($ippat,$j+1);
         return ($end<=$max);
      } else {
         return (strpos(" $ip.","$ippat.")==1);
      }
   }
                
   function splitline($s) {   //convert log entry string to associative array
      global $ipcluster;
      if (!$s) {return false;}
      $p=strpos($s,"-");
      $e["ip"]=substr($s,0,$p-1);
      $q=strpos($s," ",$p+2);
      $e["auth"]=substr($s,$p+2,$q-1-$p-2);
      $p=strpos($s,":",$q);
      $q=strpos($s,"]",$p);
      $e["date"]=substr($s,$p-11,11);
      $e["time"]=substr($s,$p+1,$q-1-$p-6);
      $p=strpos($s,"\"",$q+3);
      $e["request"]=substr($s,$q+3,$p-1-$q-2);
      $q=strpos($s," ",$p+2);
      $e["mode"]=substr($s,$p+2,$q-$p-2);
      $p=strpos($s," ",$q+1);
      $e["size"]=substr($s,$q+1,$p-$q-1);
      $q=strpos($s," ",$p+1);
      $e["domain"]=substr($s,$p+1,$q-$p-1);
      $p=strpos($s,"\"",$q+2);
      $e["refer"]=substr($s,$q+2,$p-$q-2);
      $q=strpos($s,"\"",$p+4);
      $e["useragent"]=substr($s,$p+3,$q-1-$p-2);      
      $e["ipcut"]=ipcutoff($e["ip"],$ipcluster);
      return $e;
   }            
   function fillbuffer() {       //fills buffer by reading specified number
                                 //of lines from log, keeping only displayable
                                 //entries  
      global $buffer,$bufsize,$buflines,$eof,$ips,$myips,$excludes,
             $oldweek,$fdate,$endofday;
      $buflines=0;
      if (eof()) {return;}
      $e=splitline(fgetline());
      if ($oldweek) {
         while ($e && $e['date']!=$fdate) {$e=splitline(fgetline());} 
      }     
      while ($e && ($buflines<$bufsize)) {
         while ($e && !displayentry($e)) { $e=splitline(fgetline());}
         if ($e && $e['date']==$fdate) {
            $buffer[$buflines]=$e;
            $buflines++;
         }
         if ($buflines<$bufsize) {$e=splitline(fgetline());}   
      }
      $eof=($buflines==0);
   }
      
   function getentry($prev) {      //returns next displayable entry from log,
                                   //or false if no more entries
      global $bufsize,$buffer,$buflines,$eof,$ips,$myips,$timeout,$fdate,
             $endofday,$excludes,$newheader;
      if ($eof) {return false;}
      $newheader=false;
      if (!$prev) {$newheader=true; $i=0;} else {
         $lastip=$prev['ipcut'];
         $lastagent=$prev['useragent'];
         $lasttime=strtotime($prev['time']);
         $i=0;
         while (($i<$buflines) && (($buffer[$i]["ipcut"]!=$lastip)||($buffer[$i]['useragent']!=$lastagent))) {$i++;}
         if ($i==$buflines) {$i=0; $newheader=true;} else {
            if (strtotime($buffer[$i]["time"])-$lasttime>$timeout*60) 
                {$i=0; $newheader=true;}
         }
      }
      $result=$buffer[$i];
      for ($j=$i+1;$j<$buflines;$j++) {$buffer[$j-1]=$buffer[$j];}
      if (eof()) {
         $buflines--;
         $eof=($buflines==0);
      } else {
         do {
            $e=splitline(fgetline());
         } while (!displayentry($e)&&!eof());
         if (eof()) {$buflines--;} else {
           if ($e['date']==$fdate) {$buffer[$buflines-1]=$e;}
                              else {$endofday=true; $buflines--;}   
         }
      }
      return $result;   
   }   
   
   function displayentry($e) {     //returns true if log entry $e meets 
                                   //criteria to be displayed, based on user
                                   //settings in [Excludes] and [IPs]
      global $excludes,$ips,$myips;
      if (!$e) {return false;}
      $i=0; while (($i<count($ips)) && (strpos("*".$e["ip"],$ips[$i])!=1)) {$i++;}
      if ($i<$myips) {return false;}
      $req=$e['request'];
      if (isset($_GET['find'])) {
         return strpos(" $req",$_GET['find']);
      }
      $j=0; while (($j<count($excludes)) && (!strpos($req,$excludes[$j]))) {$j++;}
      $err=($e['mode']!=200)&&($e['mode']!=304);
      return ($j==count($excludes))||$err;
   }

   function fgetline() {           //returns next entry from log, or false
                                   //if at end of log
      global $zipped,$handle;
      if (eof()) {return false;}
      if ($zipped) {return gzgets($handle,4096);} else {return fgets($handle);}
   }
       
   function eof() {                //returns true if last useable entry in log
                                   //has been delivered 
      global $zipped,$handle,$endofday,$oldweek;
      if ($endofday && $oldweek) {return true;} 
      if ($zipped) {return gzeof($handle);} else {return feof($handle);}   
   }   
   
   function configline($h) {      //returns line from logconfig.ini file, 
                                  //skipping empty lines and comments
      if (feof($h)) {return false;}
      do {
         $s=fgets($h);
         if (($p=strpos($s,"#"))!==false) {$s=substr($s,0,$p);}
         $s=trim($s);
      } while (!feof($h) && !$s);
      return $s;
   }   
      